use mio::Token;

use crate::command::CommandSetPlayer;
use crate::database::Db;
use crate::queue::SendQueue;
use crate::{try_option_send_error, try_send_error};

impl CommandSetPlayer {
	/// Set the player's password
	pub fn dispatch_password(&self, args: String, token: Token, db: &mut Db) -> SendQueue {
		let mut player = try_option_send_error!(token, db.get_connected_player(token));

		if args.is_empty() {
			return (token, "Password can't be empty").into();
		}

		player.password = args;

		let _ = try_send_error!(token, db.save_player(&player));
		let _ = try_send_error!(token, db.save_connected_player(token, &player));

		SendQueue::ok(token)
	}
}
